#include <stdlib.h>
#include <avr/io.h>
#include <util/delay.h>
#include "keyb.h"

uint8_t readKeyboard() {
	for (uint8_t row = 0; row < 4; row++){
		KEYB_PORT = ~_BV(row);
		_delay_us(1);
		for (uint8_t column = 0; column < 4; column++){
			if (~KEYB_PIN & _BV(column + 4)) {
				return row * 4 + column + 1;
			}
		}
	}
	return 0;
}

uint8_t getKey() {
	uint8_t key = 0;
	while (!(key = readKeyboard()));
	while (readKeyboard());
	_delay_ms(30);
	return key;
}

void keybInit() {
	KEYB_DDR = 0x0f;
}